﻿using NSEventDemo.NSEvent;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NSEventDemo
{
    public class CustomButton
    {
        private INotificationAdapter adapter;

        private Rectangle clientArea;

        public CustomButton(INotificationAdapter adapter, int x, int y, int w, int h)
        {
            this.adapter = adapter;

            this.clientArea = new Rectangle(x, y, w, h);
        }

        public void Update(int x, int y, bool pressed)
        {
            if (pressed && clientArea.Contains(x, y))
                this.adapter.Notify<ButtonClick>(this, new ButtonClick()
                {
                    X = x,
                    Y = y
                });
        }

        public void Draw(Graphics g)
        {
            g.FillRectangle(Brushes.Red, clientArea);
        }
    }
}
