﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NSEventDemo.NSEvent
{
    internal static class Helper
    {
        private static string INTERFACE_NAME = typeof(INotificationReceiver<dynamic>).Name;
        internal static IEnumerable<Type> GetNotificationReceivers(object instance, bool[] rslt)
        {
            Type type = instance.GetType();

            foreach (var irfc in type.GetInterfaces())
            {
                string name = irfc.Name;
                if (name.Equals(INTERFACE_NAME))
                {
                    rslt[0] = true;
                    yield return irfc;
                }
            }
        }

        internal static bool IsNotificationReceiver<T>()
        {
            foreach (var irfc in typeof(T).GetInterfaces())
            {
                string name = irfc.Name;
                if (name.Equals(INTERFACE_NAME))
                {
                    return true;
                }
            }


            return false;
        }


    }
}
